#  S.Chekanov
from jhplot  import * 
from jhplot  import  HPlot,P1D,HLabel,HKey
from java.awt import Font,Color
import math

# class to keep a single measurement
class Measurement1:
     def __init__(self, ref, mass, mass_stat_err, mass_err_left, mass_err_right, 
                             width, width_stat_err, width_err_left, width_err_right):
         "Class representing a single measurement"
         self.r_ref = ref
         self.r_mass = mass
 #        self.r_mass_err_left = math.sqrt(mass_stat_err*mass_stat_err + mass_err_left*mass_err_left) 
 #        self.r_mass_err_right = math.sqrt(mass_stat_err*mass_stat_err + mass_err_right*mass_err_right) 
         self.r_mass_stat_err = mass_stat_err
         self.r_mass_err_left = mass_err_left 
         self.r_mass_err_right = mass_err_right 
         self.r_width = width
 #        self.r_width_err_left = math.sqrt(width_stat_err*width_stat_err + width_err_left*width_err_left) 
 #        self.r_width_err_right = math.sqrt(width_stat_err*width_stat_err + width_err_right*width_err_right) 
         self.r_width_stat_err = width_stat_err
         self.r_width_err_left = width_err_left
         self.r_width_err_right = width_err_right
         self.r_y=10
         
         # keep mass
         self.p1=P1D(self.r_ref)
         self.p1.setErrSysX(1)
         self.p1.setSymbolSize(8)
         self.p1.setSymbol(4)
         self.p1.setPenWidthErr(4)
         self.p1.setPenWidthErrSys(2)
         # p1.setPenWidthErrSys(2)
         self.p1.add(self.r_mass,self.r_y,self.r_mass_stat_err,self.r_mass_stat_err,0,0,self.r_mass_err_left,self.r_mass_err_right,0,0)
         self.p1.setLegend(0)
         self.p1.setErrTicSize(3)
         self.p1.setErrSys(1)
         self.p1.setErr(1)
         self.p1.setStyle("p")
         

         # keep width         
         self.p2=P1D(self.r_ref)
         self.p2.setErrSysX(1)
         self.p2.setSymbolSize(8)
         self.p2.setSymbol(4)
         self.p2.setPenWidthErr(4)
         # p2.setPenWidthErrSys(2)
         self.p2.setPenWidthErrSys(2)
         self.p2.add(self.r_width,self.r_y,self.r_width_stat_err,self.r_width_stat_err,0,0,self.r_width_err_left,self.r_width_err_right,0,0)
         self.p2.setLegend(0)
         self.p2.setErrTicSize(3)
         self.p2.setErrSys(1)
         self.p2.setErr(1)
         self.p2.setStyle("p")
      


         # define interactive label
         self.lab=HLabel(self.r_ref,20,10)
         self.lab.setColor(Color.blue)
         big = Font("Dialog", Font.BOLD+Font.ITALIC,14) 
         self.lab.setFont(big)
 
     def printMass(self):
         print  self.r_ref, self.r_mass, self.r_mass_stat_err, self.r_mass_err_left,   self.r_mass_err_right
     def printWidth(self):
         print  self.r_ref, self.r_width,  self.r_width_err_left,   self.r_width_err_right                 


     def getMass(self):
         return self.r_mass;
     def getY(self):
         return self.r_y;
    
     def setY(self, y):
         self.r_y=y
         self.p1.clear()
         self.p2.clear()
#         self.p1.add(self.r_mass,self.r_y,self.r_mass_err_left,self.r_mass_err_right,0,0,0,0,0,0)
         self.p1.add(self.r_mass,self.r_y,self.r_mass_stat_err,self.r_mass_stat_err,0,0,self.r_mass_err_left,self.r_mass_err_right,0,0)
         self.p2.add(self.r_width,self.r_y,self.r_width_stat_err,self.r_width_stat_err,0,0,self.r_width_err_left,self.r_width_err_right,0,0)
         self.lab.setLocation(23, self.r_y, "USER")
          
     def setXY(self,x, y):
         self.r_y=y
         self.p1.clear()
         self.p2.clear()
#         self.p1.add(self.r_mass,self.r_y,self.r_mass_err_left,self.r_mass_err_right,0,0,0,0,0,0)
         self.p1.add(self.r_mass,self.r_y,self.r_mass_stat_err,self.r_mass_stat_err,0,0,self.r_mass_err_left,self.r_mass_err_right,0,0)
         self.p2.add(self.r_width,self.r_y,self.r_width_stat_err,self.r_width_stat_err,0,0,self.r_width_err_left,self.r_width_err_right,0,0)
         self.lab.setLocation(x, self.r_y, "USER")
           


     def getMass(self):       
          return self.p1
     def getWidth(self):       
          return self.p2        
     def getLabel(self):       
          return self.lab  






